#CC-RL Compiler RL78 Assembler Source
#@  CC-RL Version : V1.05.00 [26 May 2017]
#@  Commmand :
#@   -cpu=S3
#@   -obj_path=.\obj\
#@   -asm_path=.\obj\
#@   -dev=C:\Program Files (x86)\Renesas Electronics\Applilet EZ PL for RL78 V2.20\Tools\BIN\..\..\Tools\DEV\DR5F1058A.DVF
#@   -c
#@   -I C:\Program Files (x86)\Renesas Electronics\CS+\CC\CC-RL\V1.05.00\inc,.\include
#@   -Osize
#@   -pass_source
#@   src\standby11.c
#@  compiled at Wed Jun 13 16:51:38 2018

	.PUBLIC _STANDBY11_exec
	.EXTERN _standby_before_state_save
	.EXTERN _FLASHMODE_set_rower
	.EXTERN _FLASHMODE_return_beginning
	.EXTERN _standby_after_state_return
	.EXTERN _STANDBY_init

	.SECTION .textf,TEXTF
_STANDBY11_exec:
	.STACK _STANDBY11_exec = 8
	;***        1 : /*******************************************************************************
	;***        2 : * DISCLAIMER
	;***        3 : * This software is supplied by Renesas Electronics Corporation and is only
	;***        4 : * intended for use with Renesas products. No other uses are authorized. This
	;***        5 : * software is owned by Renesas Electronics Corporation and is protected under
	;***        6 : * all applicable laws, including copyright laws.
	;***        7 : * THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING
	;***        8 : * THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT
	;***        9 : * LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE
	;***       10 : * AND NON-INFRINGEMENT. ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
	;***       11 : * TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS
	;***       12 : * ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE
	;***       13 : * FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR
	;***       14 : * ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE
	;***       15 : * BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
	;***       16 : * Renesas reserves the right, without notice, to make changes to this software
	;***       17 : * and to discontinue the availability of this software. By using this software,
	;***       18 : * you agree to the additional terms and conditions found by accessing the
	;***       19 : * following link:
	;***       20 : * http://www.renesas.com/disclaimer
	;***       21 : *
	;***       22 : * Copyright (C) 2016 Renesas Electronics Corporation. All rights reserved.
	;***       23 : *******************************************************************************/
	;***       24 : 
	;***       25 : /*******************************************************************************
	;***       26 : * File Name    : standby11.c
	;***       27 : * Version      : Applilet EZ PL for RL78
	;***       28 : * Device(s)    : R5F1056A,R5F1057A,R5F1058A
	;***       29 : * Tool-Chain   : CC-RL
	;***       30 : * Description  : This file implements the function of Standby processing.
	;***       31 : * Creation Date: 2016/09/14
	;***       32 : *******************************************************************************/
	;***       33 : 
	;***       34 : /*******************************************************************************
	;***       35 : Includes <System Includes> , "Project Includes"
	;***       36 : *******************************************************************************/
	;***       37 : #include "sfr.h"
	;***       38 : #include "common.h"
	;***       39 : #include "config.h"
	;***       40 : #include "standbycommon.h"
	;***       41 : #include "standbyinit.h"
	;***       42 : #include "standby11.h"
	;***       43 : 
	;***       44 : #if defined STANDBY_USED
	;***       45 : /*******************************************************************************
	;***       46 : Macro definitions
	;***       47 : *******************************************************************************/
	;***       48 : 
	;***       49 : /*******************************************************************************
	;***       50 : Typedef definitions
	;***       51 : *******************************************************************************/
	;***       52 : 
	;***       53 : /*******************************************************************************
	;***       54 : Imported global variables and functions (from other files)
	;***       55 : *******************************************************************************/
	;***       56 : 
	;***       57 : /*******************************************************************************
	;***       58 : Exported global variables and functions (to be accessed by other files)
	;***       59 : *******************************************************************************/
	;***       60 : 
	;***       61 : /*******************************************************************************
	;***       62 : Private variables and functions
	;***       63 : *******************************************************************************/
	;***       64 : 
	;***       65 : /*******************************************************************************
	;***       66 : * Function Name: STANDBY11_exec
	;***       67 : * Description  : Setting, execution and return of a standby mode.
	;***       68 : * Arguments    : none
	;***       69 : * Return Value : none
	;***       70 : ********************************************************************************/
	;***       71 : void STANDBY11_exec( UCHAR StandbyMode, USHORT Time, UCHAR In )
	push bc
	push ax
	pop ax
	push ax
	;***       72 : {
	;***       73 : 	if (In == 0)
	cmp0 x
	bnz $.BB@LABEL@1_2
.BB@LABEL@1_1:	; return
	;***       74 : 	{
	;***       75 : 		return;
	;***       76 : 	}
	;***       77 : 	
	;***       78 : 	/* State save */
	;***       79 : 	STATE_SAVE();
	;***       80 : 	
	;***       81 : 	/* setting for standby mode. */
	;***       82 : 	/* 12bit interval timer */
	;***       83 : 	OSMC = 0x10;
	;***       84 : 	TMKAEN = 1;
	;***       85 : 	ITMC = (Time * 15) & 0x0fff;			/* 1msec = 1/15KHz * 15 */
	;***       86 : 	
	;***       87 : 	/* switch the flash operation mode. */
	;***       88 : 	TRANS_FLASHMODE();
	;***       89 : 	
	;***       90 : 	/* Interrupt enable */
	;***       91 : 	MK1H &= ~0x0002;
	;***       92 : 	/* 12 bit interval timer start */
	;***       93 : 	ITMC |= 0x8000;
	;***       94 : 	
	;***       95 : 	/* Standby mode  Execution. */
	;***       96 : 	if ( StandbyMode == STANDBY_MODE_STOP ) {
	;***       97 : 		STOP();
	;***       98 : 	}
	;***       99 : 	else
	;***      100 : 	{
	;***      101 : 		HALT();
	;***      102 : 	}
	;***      103 : 	
	;***      104 : 	/* 12 bit interval timer stop */
	;***      105 : 	ITMC = 0x0000;
	;***      106 : 	/* Interrupt disabled */
	;***      107 : 	MK1H |= 0x0002;
	;***      108 : 	
	;***      109 : 	/* switch the flash operation mode. */
	;***      110 : 	RETURN_FLASHMODE();
	;***      111 : 	
	;***      112 : 	/* State return */
	;***      113 : 	STATE_RETURN();
	;***      114 : 	
	;***      115 : 	/* Run mode initializing. */
	;***      116 : 	STANDBY_INIT0();
	;***      117 : 	
	;***      118 : }
	addw sp, #0x04
	ret
.BB@LABEL@1_2:	; if_break_bb
	call !!_standby_before_state_save
	movw de, #0x00F3
	movw ax, de
	mov [de+0x00], #0x10
	addw ax, #0x0009
	movw hl, ax
	set1 [hl].7
	movw ax, [sp+0x02]
	movw bc, ax
	shlw ax, 0x04
	subw ax, bc
	and a, #0x0F
	movw 0xFFF90, ax
	call !!_FLASHMODE_set_rower
	mov a, #0xFD
	and a, !0xFFE7
	mov 0xFFFE7, a
	movw ax, 0xFFF90
	or a, #0x80
	movw 0xFFF90, ax
	mov a, [sp+0x01]
	cmp0 a
	bnz $.BB@LABEL@1_4
.BB@LABEL@1_3:	; if_then_bb18
	stop
	br $.BB@LABEL@1_5
.BB@LABEL@1_4:	; if_else_bb
	halt
.BB@LABEL@1_5:	; if_break_bb19
	movw 0xFFF90, #0x0000
	mov a, #0x02
	or a, !0xFFE7
	mov 0xFFFE7, a
	call !!_FLASHMODE_return_beginning
	call !!_standby_after_state_return
	addw sp, #0x04
	br !!_STANDBY_init
	;***      119 : #endif /* end of defined STANDBY_USED */
